//Editable Table program written by George Koutsogiannakis 1/20/2004

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.JTable.*;
import javax.swing.table.*;

  public class EditableTable extends JFrame{
    String firstColumn;
	String firstRow;
    public EditableTable ()
    {
    super ("First Table Example of Abstract Model");
    setSize(400,400);
    
   TableModel tablemodel = new AbstractTableModel()
    {
        Object [][] data={{"George" ,"Koutsogiannakis", "young"},{"Anthony" , "Brown", "old"},{"Anna" , "Koutsogiannakis", "child"}};
        String[] headers= {"FirstName","LastName", "Age"};
        public int getRowCount(){ return data.length;}
        public int getColumnCount(){return headers.length;}
		
        public Object getValueAt(int r, int c){return data[r][c];}
		public void setValueAt(Object value, int row, int col) { 
			data[row][col] = value;
            fireTableCellUpdated(row, col);
			}
        public String getColumnName (int d) {return headers[d];}
		public Class getColumnClass(int r, int c) {
            return getValueAt(r, c).getClass();
        }
        public boolean isCellEditable(int row, int col) {
           
             if (col < 1) { 
                return false;
            } else {
                return true;
            }
        }
		

    };
     
    JTable mytable =new JTable (tablemodel); 
    JScrollPane mypane = new JScrollPane(mytable);
	mytable.setPreferredScrollableViewportSize(new Dimension(500, 270));
	
	getContentPane().add(mypane, BorderLayout.CENTER);
	
     addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
	
    
  }
 
   

   public static void main (String arg[])
   {
    EditableTable ft =new EditableTable();
	ft.pack();
    ft.setVisible(true);
    
        
        
   }
	
	class MyTableCellEditor extends AbstractCellEditor implements TableCellEditor {
        // This is the component that will handle the editing of the
        // cell value
        JComponent component = new JTextField();
    
        // This method is called when a cell value is edited by the user.
        public Component getTableCellEditorComponent(JTable table, Object value,
                boolean isSelected, int rowIndex, int vColIndex) {
            // 'value' is value contained in the cell located at
            // (rowIndex, vColIndex)
    
            if (isSelected) {
                 int row= rowIndex;
				  int col=vColIndex=1;
					
				}
    
            // Configure the component with the specified value
            ((JTextField)component).setText((String)value);
    
            // Return the configured component
            return component;
        }
    
        // This method is called when editing is completed.
        // It must return the new value to be stored in the cell.
        public Object getCellEditorValue() {
            return ((JTextField)component).getText();
        }
    }



  }

